import { jsx as i, jsxs as c, Fragment as F } from "react/jsx-runtime";
import { useState as B } from "react";
import { ArEventStates as T, ArSizes as m, ArEventTypes as I, ArButtonVariants as q } from "@armco/types";
import J from "@armco/shared-components/Button";
import P from "@armco/shared-components/SegmentedControl";
import R from "@armco/shared-components/Select";
import X from "@armco/shared-components/TextArea";
import j from "@armco/shared-components/TextInput";
import U from "@armco/shared-components/TimeEntry";
import G from "@armco/shared-components/Toggle";
import { toDate as h } from "@armco/utils/dateHelper";
import _ from "@armco/icon";
const $ = /* @__PURE__ */ c("div", { className: "ar-EventManager__no-events fw-bold flex-center h-100 flex-column", children: [
  /* @__PURE__ */ i("span", { children: "No events on this date yet." }),
  /* @__PURE__ */ i("span", { children: "Use the form on the left to select type and add an event." })
] }), H = ({
  classes: r,
  event: t,
  selectedEventType: d
}) => {
  var p, b, f, e, u, a;
  const n = t && /* @__PURE__ */ i("span", { children: t.title }), s = ((p = t == null ? void 0 : t.schedule) == null ? void 0 : p.starts) && /* @__PURE__ */ c("span", { children: [
    ". Starts:",
    " ",
    (b = t.schedule.starts) == null ? void 0 : b.toLocaleString("en-US", {
      year: "numeric",
      month: "short",
      day: "2-digit",
      hour: "2-digit",
      minute: "2-digit",
      hour12: !0
    })
  ] }), M = ((f = t == null ? void 0 : t.schedule) == null ? void 0 : f.ends) && /* @__PURE__ */ c("span", { children: [
    ", Ends:",
    " ",
    (e = t.schedule.ends) == null ? void 0 : e.toLocaleString("en-US", {
      year: "numeric",
      month: "short",
      day: "2-digit",
      hour: "2-digit",
      minute: "2-digit",
      hour12: !0
    })
  ] });
  let o = t != null && t.title ? /* @__PURE__ */ c(F, { children: [
    n,
    ((u = t.schedule) == null ? void 0 : u.starts) && /* @__PURE__ */ c(F, { children: [
      s,
      ((a = t.schedule) == null ? void 0 : a.ends) && M
    ] })
  ] }) : null;
  return t != null && t.eventType && (o = d != null && d.icon ? /* @__PURE__ */ c("span", { children: [
    /* @__PURE__ */ i(_, { attributes: { classes: "me-2" }, icon: d.icon }),
    o
  ] }) : o), /* @__PURE__ */ i(
    "span",
    {
      className: `ar-EventListItem small d-inline-block fw-bold${r ? " " + r : ""}`,
      children: o
    }
  );
}, oe = (r) => {
  const { events: t } = r;
  return /* @__PURE__ */ i("div", { className: "ar-EventList flex-grow-1 p-3", children: t && t.length > 0 ? /* @__PURE__ */ i("ul", { className: "list-unstyled", children: t.map((d) => /* @__PURE__ */ i("li", { children: /* @__PURE__ */ i(
    H,
    {
      event: d,
      selectedEventType: C.find(
        (n) => n.name === d.eventType
      )
    }
  ) })) }) : $ });
}, K = [
  {
    name: "15min",
    label: "15 minutes",
    value: "15min",
    data: { minutes: 15 }
  },
  {
    name: "30min",
    label: "30 minutes",
    value: "30min",
    data: { minutes: 30 }
  },
  {
    name: "45min",
    label: "45 minutes",
    value: "45min",
    data: { minutes: 45 }
  },
  {
    name: "1hour",
    label: "1 hour",
    value: "1hour",
    data: { hours: 1 }
  },
  {
    name: "2hours",
    label: "2 hours",
    value: "2hours",
    data: { hours: 2 }
  },
  { name: "custom", label: "Custom", value: "custom" }
], C = [
  { name: "task", label: "Task", icon: "md.MdAddTask" },
  {
    name: "event",
    label: "Event",
    icon: "md.MdOutlineEventAvailable"
  },
  {
    name: "birthday",
    label: "Birthday",
    icon: "fa.FaBirthdayCake"
  },
  {
    name: "meeting",
    label: "Meeting",
    icon: "md.MdOutlineMeetingRoom"
  }
], V = (r) => r && r.eventType && r.title && r.schedule && r.schedule.starts && r.schedule.ends, le = (r) => {
  var p, b, f;
  const { miniMode: t, onSubmit: d, selectedDate: n } = r, [s, M] = B({
    title: "",
    state: T.DRAFT,
    schedule: {}
  }), o = (e, u) => {
    var E, x, N, W;
    const a = { ...s };
    if (e === "isWholeDay" || e === "starts" || e === "ends" ? a.schedule || (a.schedule = {}) : e !== "duration" && (a[e] = u), e === "isWholeDay" && a.schedule && (a.schedule.isWholeDay = u, u && (a.schedule.starts = h(n), a.schedule.ends = h({
      ...n,
      day: n.day + 1
    }))), (e === "starts" || e === "ends") && a.schedule) {
      const l = u.raw;
      let g;
      try {
        g = l && l.hour && h(
          n,
          +(l.hour || 0),
          +(l.minute || 0),
          l.ampm
        );
      } catch {
        console.warn("Failed attempt to convert string to number");
      }
      g && (a.schedule[e] = g);
    }
    if (e === "eventType" && u === "birthday" && (a.schedule || (a.schedule = {}), a.schedule.isWholeDay = !0, a.schedule.starts = h(n), a.schedule.ends = h({
      ...n,
      day: n.day + 1
    })), e === "duration" && a.schedule) {
      const l = (E = u.data) == null ? void 0 : E.data, g = (x = a.schedule.starts) == null ? void 0 : x.getHours(), S = (N = a.schedule.starts) == null ? void 0 : N.getMinutes(), O = (W = a.schedule.starts) == null ? void 0 : W.toLocaleString("en-US", { hour12: !0 }).split(" ")[1], L = l == null ? void 0 : l.hours, A = l == null ? void 0 : l.minutes;
      let y = g, w = S, D = O, z = !1;
      A && S && S + A > 59 && (w = S + A - 60, y += 1), L && y + L >= 12 && (y = y + L - 12, D === "PM" && (z = !0), D = D === "AM" ? "PM" : "AM"), a.schedule.ends = h(
        z ? { ...n, day: n.day + 1 } : n,
        y,
        w
      );
    }
    M(a);
  };
  return /* @__PURE__ */ c(
    "div",
    {
      className: `ar-EventForm p-2 mb-3 overflow-auto ${t ? "w-100" : "border-right"}`,
      children: [
        /* @__PURE__ */ i(
          P,
          {
            classes: "mb-3",
            segments: C,
            onChange: (e) => {
              o("eventType", e.name);
            }
          }
        ),
        /* @__PURE__ */ i(
          j,
          {
            classes: "mb-3",
            label: "Title",
            size: m.SMALL,
            onChange: (e) => o("title", e.target.value),
            required: !0
          }
        ),
        /* @__PURE__ */ i(
          X,
          {
            classes: "mb-3",
            label: "Details",
            size: m.SMALL,
            onChange: (e) => o("description", e.target.value)
          }
        ),
        /* @__PURE__ */ i(
          G,
          {
            classes: "mb-3",
            label: "Whole Day?",
            onChange: (e) => o("isWholeDay", e),
            size: m.SMALL,
            isOn: (p = s == null ? void 0 : s.schedule) == null ? void 0 : p.isWholeDay,
            hideStatus: !0
          }
        ),
        /* @__PURE__ */ i(
          U,
          {
            classes: "mb-3",
            label: "Starts",
            size: m.SMALL,
            isDisabled: (b = s == null ? void 0 : s.schedule) == null ? void 0 : b.isWholeDay,
            onChange: (e) => o("starts", e),
            required: !0
          }
        ),
        (s == null ? void 0 : s.eventType) && (s == null ? void 0 : s.eventType) !== I.MEETING && /* @__PURE__ */ i(
          U,
          {
            classes: "mb-4",
            label: "Ends",
            size: m.SMALL,
            isDisabled: (f = s == null ? void 0 : s.schedule) == null ? void 0 : f.isWholeDay,
            onChange: (e) => o("ends", e),
            required: !0
          }
        ),
        (s == null ? void 0 : s.eventType) === I.MEETING && /* @__PURE__ */ i(
          R,
          {
            classes: "mb-3",
            options: K,
            onSelectionChanged: (e) => o("duration", e),
            size: m.SMALL,
            isDisabled: !s.schedule || !s.schedule.starts
          }
        ),
        /* @__PURE__ */ i(
          H,
          {
            classes: "mb-4",
            event: s,
            selectedEventType: C.find(
              (e) => e.name === s.eventType
            )
          }
        ),
        /* @__PURE__ */ i(
          J,
          {
            size: m.SMALL,
            content: "OK",
            variant: q.SUCCESS,
            onClick: () => {
              s && V(s) && (s.state = T.SCHEDULED, d && d(s), M({
                title: "",
                state: T.DRAFT,
                schedule: {}
              }));
            }
          }
        )
      ]
    }
  );
};
export {
  oe as E,
  le as a,
  H as b,
  C as s
};
